"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OData4JsonAjaxAdapter = void 0;
var breeze_client_1 = require("breeze-client");
var ts_odatajs_1 = require("ts-odatajs");
var breeze_odata4_ajax_adapter_1 = require("./breeze-odata4-ajax-adapter");
var ContentIdHeader = 'Content-ID';
var OData4JsonAjaxAdapter = (function (_super) {
    __extends(OData4JsonAjaxAdapter, _super);
    function OData4JsonAjaxAdapter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = OData4JsonAjaxAdapter.BreezeAdapterName;
        return _this;
    }
    OData4JsonAjaxAdapter.register = function () {
        breeze_client_1.config.registerAdapter('ajax', OData4JsonAjaxAdapter);
    };
    OData4JsonAjaxAdapter.prototype.ajax = function (ajaxConfig, httpClient, metadata) {
        var _this = this;
        var batchRequest = (ajaxConfig.data || {});
        var changeRequests = (batchRequest.__batchRequests || [])
            .flatMap(function (br) { return br.__changeRequests || []; });
        var promises = changeRequests.map(function (cr) {
            var result = new Promise(function (resolve, reject) {
                var headers = __assign(__assign({}, ajaxConfig.headers), cr.headers);
                var contentId = headers[ContentIdHeader];
                var request = {
                    method: cr.method,
                    requestUri: cr.requestUri,
                    headers: headers,
                    data: cr.data
                };
                ts_odatajs_1.oData.request(request, function (_data, response) {
                    var _a;
                    response.headers = __assign((_a = {}, _a[ContentIdHeader] = contentId.toString(), _a), response.headers);
                    resolve(response);
                }, function (error) {
                    var _a;
                    if (error === null || error === void 0 ? void 0 : error.response) {
                        error.response.headers = __assign((_a = {}, _a[ContentIdHeader] = contentId.toString(), _a), error.response.headers);
                    }
                    reject(error);
                }, ts_odatajs_1.oData.jsonHandler, httpClient, metadata);
            });
            return result;
        });
        Promise.allSettled(promises)
            .then(function (responses) {
            var changeResponses = responses.filter(function (x) { return x.status === 'fulfilled'; })
                .map(function (x) { return x.value; });
            var failedResponses = responses.filter(function (x) { return x.status === 'rejected'; })
                .map(function (x) {
                var error = x.reason;
                var result = {
                    message: error.message,
                    response: error.response
                };
                return result;
            });
            var batchResponse = {
                __batchResponses: [{
                        __changeResponses: __spreadArray(__spreadArray([], changeResponses, true), failedResponses, true)
                    }]
            };
            var httpResponse = {
                config: ajaxConfig,
                data: batchResponse,
                error: null,
                getHeaders: function (name) { var _a; return (_a = _this.defaultSettings) === null || _a === void 0 ? void 0 : _a.headers[name]; },
                status: 200
            };
            ajaxConfig.success(httpResponse);
        })
            .catch(function (reason) { return ajaxConfig.error(reason); });
    };
    OData4JsonAjaxAdapter.BreezeAdapterName = 'OData4Json';
    return OData4JsonAjaxAdapter;
}(breeze_odata4_ajax_adapter_1.OData4AjaxAdapter));
exports.OData4JsonAjaxAdapter = OData4JsonAjaxAdapter;
//# sourceMappingURL=breeze-odata4-json-ajax-adapter.js.map