"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OData4DataServiceAdapter = void 0;
var breeze_client_1 = require("breeze-client");
var ts_odatajs_1 = require("ts-odatajs");
var breeze_jsonResultsAdapter_factory_1 = require("./breeze-jsonResultsAdapter-factory");
var options_1 = require("./options");
var utilities_1 = require("./utilities");
var OData4DataServiceAdapter = (function (_super) {
    __extends(OData4DataServiceAdapter, _super);
    function OData4DataServiceAdapter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._options = options_1.DefaultDataServiceAdapterOptions;
        _this.actions = [];
        _this.name = OData4DataServiceAdapter.BreezeAdapterName;
        return _this;
    }
    Object.defineProperty(OData4DataServiceAdapter.prototype, "options", {
        get: function () {
            return this._options;
        },
        enumerable: false,
        configurable: true
    });
    OData4DataServiceAdapter.register = function () {
        breeze_client_1.config.registerAdapter('dataService', OData4DataServiceAdapter);
    };
    OData4DataServiceAdapter.prototype._prepareSaveBundle = function (saveContext, saveBundle) {
        var _this = this;
        var changeRequestInterceptor = this._createChangeRequestInterceptor(saveContext, saveBundle);
        var changeRequests = [];
        saveContext.tempKeys = [];
        saveContext.contentKeys = [];
        var contentId = 1;
        saveBundle.entities.forEach(function (entity, index) {
            var changeRequest = _this.ajaxImpl.createChangeRequest(saveContext, entity, contentId);
            if (!changeRequest) {
                return;
            }
            var request = changeRequestInterceptor.getRequest(changeRequest, entity, index);
            changeRequests.push(request);
            contentId++;
        });
        changeRequestInterceptor.done(changeRequests);
        var changeRequestSet = [
            {
                __changeRequests: changeRequests
            }
        ];
        var batchRequest = {
            __batchRequests: changeRequestSet
        };
        return batchRequest;
    };
    OData4DataServiceAdapter.prototype._prepareSaveResult = function (saveContext, data, reject) {
        var responseData = data.data;
        var changeResponses = [];
        var failedResponses = [];
        responseData.__batchResponses
            .flatMap(function (br) { return br.__changeResponses; })
            .forEach(function (cr) {
            var response = cr.response || cr;
            var statusCode = Number(response.statusCode || '0');
            var wasSuccessful = statusCode >= 200 && statusCode <= 299;
            if (wasSuccessful) {
                changeResponses.push(cr);
            }
            else {
                failedResponses.push(cr);
            }
        });
        var entityErrors = this.ajaxImpl.prepareSaveErrors(saveContext, failedResponses);
        if (entityErrors.length && this._options.failOnSaveError) {
            var saveError = __assign(__assign({}, data), { entityErrors: entityErrors, httpResponse: data, message: utilities_1.Utilities.createError(data, saveContext.requestUri).message, name: null });
            reject(saveError);
            return;
        }
        var saveResult = this.ajaxImpl.prepareSaveResult(saveContext, changeResponses);
        saveResult.entityErrors = entityErrors;
        return saveResult;
    };
    OData4DataServiceAdapter.prototype.configure = function (options) {
        options = options || {};
        options.headers = __assign(__assign({}, this._options.headers), options.headers);
        this._options = __assign(__assign({}, this._options), options);
    };
    OData4DataServiceAdapter.prototype.initialize = function () {
        _super.prototype.initialize.call(this);
        this.jsonResultsAdapter = breeze_jsonResultsAdapter_factory_1.JsonResultsAdapterFactory.create();
    };
    OData4DataServiceAdapter.prototype.getAbsoluteUrl = function (dataService, url) {
        var serviceName = dataService.qualifyUrl('');
        var base = breeze_client_1.core.stringStartsWith(url, serviceName) ? '' : serviceName;
        if (typeof window !== 'undefined' && !serviceName.startsWith('//') && !serviceName.startsWith('http')) {
            base = "".concat(location.origin).concat(breeze_client_1.core.stringStartsWith(serviceName, '/') ? '' : '/').concat(base);
        }
        return base + url;
    };
    OData4DataServiceAdapter.prototype.fetchMetadata = function (metadataStore, dataService) {
        var _this = this;
        var serviceName = dataService.serviceName;
        var url = this.getAbsoluteUrl(dataService, '$metadata');
        return new Promise(function (resolve, reject) {
            ts_odatajs_1.oData.read({
                requestUri: url,
                headers: __assign(__assign({}, _this._options.headers), { Accept: _this._options.metadataAcceptHeader })
            }, function (data) {
                if (!(data === null || data === void 0 ? void 0 : data.dataServices)) {
                    var error = new Error("Metadata query failed for: ".concat(url));
                    return reject(error);
                }
                _this.metadata = data;
                var csdlMetadata = _this.metadata.dataServices;
                utilities_1.Utilities.adaptMetadata(_this.metadata);
                if (!metadataStore.hasMetadataFor(serviceName)) {
                    try {
                        metadataStore.importMetadata(csdlMetadata);
                    }
                    catch (e) {
                        reject(new Error("Metadata query failed for ".concat(url, "; Unable to process returned metadata: ").concat(e.message)));
                    }
                    metadataStore.addDataService(dataService);
                }
                _this.actions = utilities_1.Utilities.getActions(_this.metadata, metadataStore);
                resolve(csdlMetadata);
            }, function (error) {
                var err = utilities_1.Utilities.createError(error, url);
                err.message = "Metadata query failed for: ".concat(url, "; ").concat(err.message);
                reject(err);
            }, ts_odatajs_1.oData.metadataHandler, _this._options.httpClient);
        });
    };
    OData4DataServiceAdapter.prototype.executeQuery = function (mappingContext) {
        var _this = this;
        var query = mappingContext.query;
        var request = this.getRequest(mappingContext);
        return new Promise(function (resolve, reject) {
            ts_odatajs_1.oData.request(request, function (data, response) {
                var inlineCount;
                var results;
                if (data) {
                    inlineCount = Number(data['@odata.count']);
                    results = data.value;
                }
                resolve({ results: results, query: query, inlineCount: inlineCount, httpResponse: response });
            }, function (error) {
                var err = utilities_1.Utilities.createError(error, request.requestUri);
                reject(err);
            }, null, _this._options.httpClient);
        });
    };
    OData4DataServiceAdapter.prototype.saveChanges = function (saveContext, saveBundle) {
        var _this = this;
        saveContext.adapter = this;
        saveContext.routePrefix = this.getAbsoluteUrl(saveContext.dataService, '');
        saveContext.requestUri = "".concat(saveContext.routePrefix, "$batch");
        var requestData = this._prepareSaveBundle(saveContext, saveBundle);
        var result = new Promise(function (resolve, reject) {
            _this.ajaxImpl.ajax({
                type: 'POST',
                url: saveContext.requestUri,
                headers: __assign({}, _this._options.headers),
                data: requestData,
                success: function (response) {
                    response.saveContext = saveContext;
                    var data = response.data;
                    if (data.__batchResponses) {
                        var saveResult = _this._prepareSaveResult(saveContext, response, reject);
                        saveResult.httpResponse = response;
                        resolve(saveResult);
                    }
                    else {
                        var error = utilities_1.Utilities.createError(response, saveContext.requestUri);
                        reject(error);
                    }
                },
                error: function (res) {
                    res.saveContext = saveContext;
                    var error = utilities_1.Utilities.createError(res, saveContext.requestUri);
                    reject(error);
                }
            }, _this._options.httpClient, _this.metadata);
        });
        return result;
    };
    OData4DataServiceAdapter.prototype.getRequest = function (mappingContext) {
        var _a;
        var query = mappingContext.query;
        var method = 'GET';
        var request = {
            method: method,
            requestUri: this.getUrl(mappingContext),
            headers: __assign({}, this._options.headers)
        };
        if (!(query === null || query === void 0 ? void 0 : query.parameters)) {
            return request;
        }
        method = query.parameters['$method'] || method;
        delete query.parameters['$method'];
        if (method === 'GET') {
            request = __assign(__assign({}, request), { requestUri: this.addQueryString(request.requestUri, query.parameters) });
        }
        else {
            var data = (_a = this.getData(mappingContext, query.parameters['$data'])) !== null && _a !== void 0 ? _a : query.parameters;
            request = __assign(__assign({}, request), { method: method, data: data });
        }
        return request;
    };
    OData4DataServiceAdapter.prototype.getData = function (mappingContext, data) {
        if (!data) {
            return null;
        }
        if (!this.areValidPropertyNames(mappingContext.metadataStore, data)) {
            return data;
        }
        var helper = mappingContext.entityManager.helper;
        if (data.entityType || data.complexType) {
            return helper.unwrapInstance(data, null);
        }
        var invokeConfig = this.getInvokableConfig(mappingContext.query.resourceName);
        var actionEntry = this.actions.find(function (e) { return e.config === invokeConfig; });
        if (!actionEntry) {
            return data;
        }
        var paramStartIndex = Number((invokeConfig.isBound === 'true'));
        var param = invokeConfig.parameter.find(function (p, idx) {
            var isParameter = idx >= paramStartIndex;
            var isEdmType = p.type.startsWith('Edm.');
            var result = isParameter && !isEdmType;
            return result;
        });
        if (!param) {
            return data;
        }
        var edmType = utilities_1.Utilities.getEdmTypeFromTypeName(this.metadata, param.type);
        if (!edmType) {
            return data;
        }
        var structuralType = utilities_1.Utilities.adaptStructuralType(mappingContext.metadataStore, edmType);
        if (structuralType instanceof breeze_client_1.EntityType) {
            data = structuralType.createEntity(data);
            return helper.unwrapInstance(data, null);
        }
        else if (structuralType instanceof breeze_client_1.ComplexType) {
            data = structuralType.createInstance(data);
            return helper.unwrapInstance(data, null);
        }
        return data;
    };
    OData4DataServiceAdapter.prototype.areValidPropertyNames = function (metadataStore, data) {
        var props = Object.keys(data);
        var result = props.every(function (p) {
            var sp = metadataStore.namingConvention.clientPropertyNameToServer(p);
            var cp = metadataStore.namingConvention.serverPropertyNameToClient(sp);
            return p === cp;
        });
        return result;
    };
    OData4DataServiceAdapter.prototype.getInvokableConfig = function (url) {
        if (!url) {
            return null;
        }
        var invokableName = url.split('/').pop().split('(')[0];
        var actionConfig = ts_odatajs_1.oData.utils.lookupAction(invokableName, this.metadata);
        var functionConfig = ts_odatajs_1.oData.utils.lookupFunction(invokableName, this.metadata);
        return actionConfig || functionConfig;
    };
    OData4DataServiceAdapter.prototype.getUrl = function (mappingContext) {
        var url = this.getAbsoluteUrl(mappingContext.dataService, mappingContext.getUrl());
        return url;
    };
    OData4DataServiceAdapter.prototype.addQueryString = function (url, parameters) {
        var queryString = this.toQueryString(parameters);
        if (!queryString) {
            return url;
        }
        var sep = url.indexOf('?') < 0 ? '?' : '&';
        url += sep + queryString;
        return url;
    };
    OData4DataServiceAdapter.prototype.toQueryString = function (payload) {
        var keys = Object.keys(payload);
        if (!keys.length) {
            return null;
        }
        var result = keys
            .map(function (key) {
            return "".concat(encodeURIComponent(key), "=").concat(encodeURIComponent(payload[key]));
        })
            .join('&');
        return result;
    };
    OData4DataServiceAdapter.BreezeAdapterName = 'OData4';
    return OData4DataServiceAdapter;
}(breeze_client_1.AbstractDataServiceAdapter));
exports.OData4DataServiceAdapter = OData4DataServiceAdapter;
//# sourceMappingURL=breeze-odata4-dataService-adapter.js.map