"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultNavigationAdapterOptions = void 0;
exports.DefaultNavigationAdapterOptions = {
    allowManyToMany: false,
    foreignKeyConventions: [
        function (endpoint, suffix) { return "".concat(endpoint.propertyName).concat(suffix).toLowerCase(); },
        function (endpoint) { return "".concat(endpoint.propertyName, "Id").toLowerCase(); },
        function (endpoint, suffix) { return "".concat(endpoint.partnerEntityShortName).concat(suffix).toLowerCase(); },
        function (endpoint) { return "".concat(endpoint.partnerEntityShortName, "Id").toLowerCase(); },
        getPartialMatchingProperty,
        function (endpoint) { return getPartialMatchingProperty(endpoint, 'id'); }
    ],
    inferNavigationPropertyPartner: true,
    inferReferentialConstraints: true
};
function getPartialMatchingProperty(endpoint, suffix) {
    var propertyName = endpoint.propertyName.toLowerCase();
    var partnerEntityName = endpoint.partnerEntityShortName.toLowerCase();
    var propertyEnd = propertyName.replace(partnerEntityName, '');
    if (!propertyEnd || propertyEnd === suffix) {
        return null;
    }
    var result = "".concat(propertyEnd).concat(suffix).toLowerCase();
    return result;
}
//# sourceMappingURL=navigation-adapter-options.js.map