import { Edm, EdmExtra, Edmx } from 'ts-odatajs';
import { AssociationSet } from '../models';
import { NavigationAdapterOptions } from '../options';
import { MetadataAdapter } from './metadata-adapter';
export declare const EntityNotFound = "Could not find entity with type name";
export declare class NavigationAdapter implements MetadataAdapter {
    private static _defaultOptions;
    private static _options;
    private metadata;
    private entityContainer;
    private associations;
    static configure(options: Partial<NavigationAdapterOptions>): void;
    static get options(): Readonly<NavigationAdapterOptions>;
    adapt(metadata: Edmx.DataServices): void;
    adaptSchema(schema: Edm.Schema): void;
    private adaptEntityType;
    private adaptNavigationProperty;
    private getUnderlyingEntityType;
    private trySetReferentialConstraint;
    private getAllTypes;
    private getKeys;
    private getNavigationProperties;
    private getProperties;
    private tryGetPartnerNavigationProperty;
    private validateRelationship;
    private getEntitySetNameByEntityType;
    private navigationPropertyTypeMatches;
    private setAssociationSet;
    private setAssociations;
    private getAssociationEndpoint;
    processAssociation(association: AssociationSet): EdmExtra.Association;
    private getReferentialConstraint;
}
