import { AjaxAdapter, AjaxConfig, DataProperty, Entity, EntityAspect, SaveResult } from 'breeze-client';
import { EntityError, EntityErrorFromServer } from 'breeze-client/src/entity-manager';
import { AjaxRequest } from 'breeze-client/src/interface-registry';
import { Batch, Edmx } from 'ts-odatajs';
import { DataServiceSaveContext } from '../breeze-odata4-dataService-adapter';
import { ODataError } from '../odata-error';
import { ODataHttpClient } from '../odata-http-client';
export interface ODataEntityError extends EntityError, EntityErrorFromServer {
    error: ODataError;
}
export declare abstract class OData4AjaxAdapter implements AjaxAdapter {
    abstract name: string;
    abstract ajax(ajaxConfig: AjaxConfig, httpClient?: ODataHttpClient, metadata?: Edmx.Edmx): void;
    _$impl?: any;
    checkForRecomposition?: (context: any) => void;
    defaultSettings: {
        headers?: {
            [name: string]: string;
        };
    };
    requestInterceptor?: (req: AjaxRequest) => void;
    initialize(): void;
    createChangeRequest(saveContext: DataServiceSaveContext, entity: Entity, contentId: number): Batch.ChangeRequest;
    prepareSaveErrors(saveContext: DataServiceSaveContext, failedResponses: Batch.FailedResponse[]): ODataEntityError[];
    prepareSaveResult(saveContext: DataServiceSaveContext, changeResponses: Batch.ChangeResponse[]): SaveResult;
    protected transformValue(prop: DataProperty, val: any): any;
    protected updateDeleteMergeRequest(request: Batch.ChangeRequest, aspect: EntityAspect, routePrefix: string): void;
    private fmtProperty;
    private getUriKey;
}
