import { AbstractDataServiceAdapter, DataService, HttpResponse, JsonResultsAdapter, MappingContext, MetadataStore, QueryResult, SaveBundle, SaveContext, SaveResult } from 'breeze-client';
import { Batch, Edmx } from 'ts-odatajs';
import { OData4AjaxAdapter, ODataEntityError } from './ajax-adapters';
import { DataServiceAdapterOptions } from './options';
export interface DataServiceSaveContext extends SaveContext {
    contentKeys: any[];
    requestUri: string;
    tempKeys: any[];
}
export interface SaveResultWithErrors extends SaveResult {
    entityErrors: ODataEntityError[];
}
export declare class OData4DataServiceAdapter extends AbstractDataServiceAdapter {
    private _options;
    static BreezeAdapterName: string;
    private actions;
    ajaxImpl: OData4AjaxAdapter;
    name: string;
    metadata: Edmx.Edmx;
    jsonResultsAdapter: JsonResultsAdapter;
    get options(): Readonly<DataServiceAdapterOptions>;
    static register(): void;
    _prepareSaveBundle(saveContext: DataServiceSaveContext, saveBundle: SaveBundle): Batch.BatchRequest;
    _prepareSaveResult(saveContext: DataServiceSaveContext, data: HttpResponse, reject?: (reason?: any) => void): SaveResultWithErrors;
    configure(options: Partial<DataServiceAdapterOptions>): void;
    initialize(): void;
    getAbsoluteUrl(dataService: DataService, url: string): string;
    fetchMetadata(metadataStore: MetadataStore, dataService: DataService): Promise<Edmx.DataServices>;
    executeQuery(mappingContext: MappingContext): Promise<QueryResult>;
    saveChanges(saveContext: DataServiceSaveContext, saveBundle: SaveBundle): Promise<SaveResultWithErrors>;
    private getRequest;
    private getData;
    private areValidPropertyNames;
    private getInvokableConfig;
    private getUrl;
    private addQueryString;
    private toQueryString;
}
